var app = angular.module('etm', [
  'ionic'
  ,'ionic.cloud'
  ,'ionic-material'
  ,'ionic.native'
  ,'ionic.wizard'
  ,'ngMessages'
  ,'ngCordova'
  ,'angular-cache'
  ,'firebase'
  ,'pascalprecht.translate'
  ,'jett.ionic.filter.bar'

  ,'etm.providers'
  ,'etm.filters'
  ,'etm.directives'
])

.run(function($ionicPlatform, $timeout, $ionicDeploy, $ionicPopup, AuthService, AUTH_EVENTS, $rootScope, $state) {

  $ionicPlatform.ready(function() {
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);
    }
    if (window.StatusBar) {
      StatusBar.styleDefault();
    }

    if (typeof(PushNotification) != "undefined"){
      var push = PushNotification.init({
      android: {
        senderID: "109673963020",
        iconColor: "#1b3e73",
        icon: "icon"
      },
      ios: {
        alert: true,
        badge: true,
        sound: true
      },
      windows: {}
      });

      push.on('registration', function(data) {
        window.localStorage.setItem('deviceToken', data.registrationId);
      });

      push.on('notification', function(data) {
        var meta = data.additionalData;

        if(meta.foreground){
          $ionicPopup.alert({
            title: data.title,
            template: data.message
          });
        }
      });

      push.on('error', function(e) {
        $ionicPopup.alert({
          title: 'Push Notification Error',
          template: e.message
        });
      });

    }
  });


  $rootScope.$on('$stateChangeStart', function (event,next, nextParams, fromState) {
    // if ('data' in next && 'authorizedRoles' in next.data) {
    //   var authorizedRoles = next.data.authorizedRoles;
    //   console.log($state.current);
    //   if (!AuthService.isAuthorized(authorizedRoles)) {
    //     event.preventDefault();
    //     $state.go($state.current, {}, {reload: true});
    //     $rootScope.$broadcast(AUTH_EVENTS.notAuthorized);
    //   }
    // }
    
    if (!AuthService.isAuthenticated()) {
      if (next.name !== 'login') {
        event.preventDefault();
        $state.transitionTo('login');
      }
    }
  });

  $ionicDeploy.channel = 'production';
  var checkInterval = 300000; // 5mins
  var countUp = function() {
    $ionicDeploy.check().then(function(hasUpdate) {
      if (hasUpdate) {
        $ionicDeploy.download().then(function() {
          $ionicDeploy.extract().then(function(){
            $ionicPopup.show({
              title: 'Update available',
              subTitle: 'An update was just downloaded. Would you like to restart your app to use the latest features?',
              buttons: [
                { text: 'Not now' },
                {
                  text: 'Restart',
                  type: 'button-positive',
                  onTap: function(e) {
                    $ionicDeploy.load();
                  }
                }
              ]
            });
          });
        });
      }else{
        $timeout(countUp, checkInterval);
      }
    });
  };
  countUp();

})

.config(function($ionicCloudProvider, $translateProvider, $translateStaticFilesLoaderProvider, FURL, $ionicCloudProvider, $ionicConfigProvider) {
  firebase.initializeApp(FURL);
  $ionicCloudProvider.init({
    "core": {
      "app_id": "9bf82eb5"
    }
  });

  $translateProvider.preferredLanguage('en');
  $translateProvider.useSanitizeValueStrategy('sanitize');
  $translateProvider.fallbackLanguage("en");
  $translateProvider.useStaticFilesLoader({
    prefix: 'langs/lang-',
    suffix: '.json'
  });

  $ionicConfigProvider.navBar.alignTitle('center');

});
