app.config(function($stateProvider, $urlRouterProvider, USER_ROLES) {
  
  $stateProvider
    .state('login', {
      url: '/login',
      templateUrl: 'pages/login/login.html',
      controller: 'LoginCtrl'
    })

    .state('app', {
      url: '/app',
      abstract: true,
      templateUrl: 'pages/menu/menu.html',
      controller: 'AppCtrl'
    })

    .state('app.agenda', {
      url: '/agenda',
      views: {
        'menuContent': {
          templateUrl: 'pages/agenda/agenda.html',
          controller: 'AgendaCtrl'
        }
      },
      data: {
        authorizedRoles: [USER_ROLES.user]
      }
    })

    .state('app.event', {
      url: "/agenda/:eventId",
      views: {
        'menuContent': {
          templateUrl: "pages/agenda/event.html",
          controller: 'EventCtrl'
        }
      },
      data: {
        authorizedRoles: [USER_ROLES.user]
      }
    })

    .state('app.maps', {
      url: '/maps',
      views: {
        'menuContent': {
          templateUrl: 'pages/maps/maps.html',
          controller: 'MapsCtrl'
        }
      },
      data: {
        authorizedRoles: [USER_ROLES.user]
      }
    })

    .state('app.map', {
      url: '/maps/:mapID',
      views: {
        'menuContent': {
          templateUrl: 'pages/maps/map.html',
          controller: 'MapCtrl'
        }
      },
      data: {
        authorizedRoles: [USER_ROLES.user]
      }
    })

    .state('app.mapImg', {
      url: '/maps/:mapID',
      views: {
        'menuContent': {
          templateUrl: 'pages/maps/mapImg.html',
          controller: 'MapImgCtrl'
        }
      },
      data: {
        authorizedRoles: [USER_ROLES.user]
      }
    })

    .state('app.announcements', {
      url: '/announcements',
      views: {
        'menuContent': {
          templateUrl: 'pages/announcements/announcements.html',
          controller: 'AnnouncementsCtrl'
        }
      },
      data: {
        authorizedRoles: [USER_ROLES.user]
      }
    })

    .state('app.contact', {
      url: '/contact',
      views: {
        'menuContent': {
          templateUrl: 'pages/contact/contact.html',
          controller: 'ContactCtrl'
        }
      },
      data: {
        authorizedRoles: [USER_ROLES.user]
      }
    })

    .state('app.attendees', {
      url: '/attendees',
      views: {
        'menuContent': {
          templateUrl: 'pages/attendees/attendees.html',
          controller: 'AttendeesCtrl'
        }
      },
      data: {
        authorizedRoles: [USER_ROLES.user]
      }
    })

    .state('app.survey', {
      url: '/survey',
      views: {
        'menuContent': {
          templateUrl: 'pages/survey/survey.html',
          controller: 'SurveyCtrl'
        }
      },
      data: {
        authorizedRoles: [USER_ROLES.user]
      }
    })

    .state('app.polls', {
      url: '/polls',
      views: {
        'menuContent': {
          templateUrl: 'pages/polls/polls.html',
          controller: 'PollsCtrl'
        }
      },
      data: {
        authorizedRoles: [USER_ROLES.user]
      }
    })

    .state('app.feed', {
      url: '/feed',
      views: {
        'menuContent': {
          templateUrl: 'pages/feed/feed.html',
          controller: 'FeedCtrl'
        }
      },
      data: {
        authorizedRoles: [USER_ROLES.user]
      }
    })

    .state('app.post', {
      url: "/post/:id",
      views: {
        'menuContent': {
          templateUrl: "pages/post/post.html",
          controller: 'PostCtrl'
        }
      },
      data: {
        authorizedRoles: [USER_ROLES.user]
      }
    })

    .state('app.sponsors', {
      url: '/sponsors',
      views: {
        'menuContent': {
          templateUrl: 'pages/sponsors/sponsors.html',
          controller: 'SponsorsCtrl'
        }
      },
      data: {
        authorizedRoles: [USER_ROLES.user]
      }
    })

    .state('app.speakers', {
      url: '/speakers',
      views: {
        'menuContent': {
          templateUrl: 'pages/speakers/speakers.html',
          controller: 'SpeakersCtrl'
        }
      },
      data: {
        authorizedRoles: [USER_ROLES.user]
      }
    })

    .state('app.speaker', {
      url: "/speakers/:speakerID",
      views: {
        'menuContent': {
          templateUrl: "pages/speakers/speaker.html",
          controller: 'SpeakerCtrl'
        }
      },
      data: {
        authorizedRoles: [USER_ROLES.user]
      }
    })

    ;

  $urlRouterProvider.otherwise(function ($injector, $location) {
    var $state = $injector.get("$state");
    $state.go("app.agenda");
  });
})

.run(function ($rootScope, $state, AuthService, AUTH_EVENTS) {
  $rootScope.$on('$stateChangeStart', function (event,next, nextParams, fromState) {
    if (!AuthService.isAuthenticated()) {
      if (next.name !== 'login') {
        event.preventDefault();
        $state.go('login');
      }
    }
  });
});