app.controller('FeedCtrl', function ($scope, ionicMaterialInk, $firebaseStorage, AuthService, $ionicModal, $ionicPlatform, $timeout, $cordovaCamera, $firebaseArray) {

    //$scope.modePrefix = 'test-';
    $scope.modePrefix = '';

    var feedRef = firebase.database().ref( $scope.modePrefix + "feed" );
    var feedQuery = feedRef.orderByChild("timestamp")

    var reg = AuthService.user().registrant;
    var post = { "post" : "", "tmpImg" : "" };
    
    $ionicPlatform.ready(function(){
      $scope.isWebView = ionic.Platform.isWebView();
      if ( $scope.isWebView ) {
        $scope.isWebView = (window.Camera !== undefined) ? true : false;
      }
    });
    $scope.newPost = post;
    $scope.cancelPost = cancelPost;
    $scope.takePicture = takePicture;

    $scope.arFeed = $firebaseArray(feedQuery);

    //fetchLatestFeed( 1000 );
    //fetchFeedCount();

    //set the feed count once then we will update this value when they choose to refresh which means they wish to load the most recent posts..
    

    $ionicModal.fromTemplateUrl('templates/feed-post-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.modal = modal;
    });


    $scope.savePost = function( postToSave ) {
      // console.log('thePostCount');
      // console.log(thePostCount);
      if ( postToSave.post.length || postToSave.tmpImg.length ) {
          
          var newPostRef = feedRef.push();
          var thePost = {
            "post": postToSave.post,
            "timestamp": -new Date().getTime(),
            "like_count" : 0,
            "date_dsp" : new Date(),
            "imgURL": "",
            "regid": reg.registrantid,
            "name": reg.registrantfirstname + ' ' + reg.registrantlastname
          };
          if ( postToSave.tmpImg.length ) {

              var imgStorageRef = firebase.storage().ref( $scope.modePrefix + "feed-imgs/" + newPostRef.key + ".jpg" );
              var imgStorage = $firebaseStorage( imgStorageRef );
              var uploadTask = imgStorage.$putString( postToSave.tmpImg, 'base64', { contentType: "image/jpeg" });

              // uploadTask.$progress(function(snapshot) {
              //   var percentUploaded = ( snapshot.bytesTransferred / snapshot.totalBytes ) * 100;
              //   console.log( percentUploaded );
              // });

              uploadTask.$complete(function(snapshot) {
                  thePost.imgURL = snapshot.downloadURL;
                  newPostRef.set( thePost );
              });
          }  else {
            newPostRef.set( thePost );
          }
          
          $scope.tmpDspImg = "";
          $scope.newPost = { "post" : "", "tmpImg" : "" };
          
          $scope.modal.hide();      
      }
    };

    function cancelPost() {
      $scope.modal.hide();
      $scope.tmpDspImg = ""
      $scope.newPost = { "post" : "", "tmpImg" : "" };
    }

    function takePicture() {
      if ( $scope.isWebView ) {
        var options = {
          quality : 95,
          destinationType : Camera.DestinationType.DATA_URL,
          sourceType : Camera.PictureSourceType.CAMERA,
          allowEdit : true,
          encodingType: Camera.EncodingType.JPEG,
          popoverOptions: CameraPopoverOptions,
          saveToPhotoAlbum: false
        };
        
        //show the camera and get a picture
        $cordovaCamera.getPicture( options ).then(function(imageData) {
            //console.log(imageData);
            $scope.tmpDspImg = "data:image/jpeg;base64," + imageData;
            $scope.newPost.tmpImg = imageData;
            
        }, function(error) {
            //console.log('error');
        });
        
      } else {
        //console.log('here no webview')
      }


    }
});