﻿app.controller('LoginCtrl', function($scope, $state, $ionicPopup, AuthService, $ionicLoading, $ionicActionSheet) {
  // $scope.data = {
  //   email : 'rpotter@travizon.com',
  //   registrantID : '181630'
  // };
  $scope.data = {
    email : '',
		registrantID : ''
	};
  $scope.onlyNumbers = /^\d+$/;

	$scope.doLogin = function(frm){
    if (frm.$valid) {
      $ionicLoading.show();
      var newEmail = $scope.data.email;
      var newRegistrantID = $scope.data.registrantID;
      AuthService.login({
        email: newEmail, 
      	registrantID: newRegistrantID, 
      	authType : "emailRegID"
     	}).then(function(ret) {
      	$ionicLoading.hide();

        if(!ret.registrants){
          $ionicPopup.alert({
            title: 'Login Failed!',
            template: "Unknown Error"
          });
          return false;
        }
        
        if(ret.registrants.length){
    	    var regs = [];
    	    for (var i = 0; i < ret.registrants.length; i++) {
    	    	regs.push({
    	    		text : ret.registrants[i].registrantfirstname + ' ' + ret.registrants[i].registrantlastname
    	    	});
    	    }
    	   	var hideSheet = $ionicActionSheet.show({
    	     buttons: regs,
    	     titleText: 'Choose who you would like to login as',
    	     buttonClicked: function(index) {
    	       $ionicLoading.show();
    	       AuthService.login({
             	registrantid: ret.registrants[index].registrantid, 
             	authType : "registrantid"
          	}).then(function(ret) {
          		$state.go('app.agenda');
              $ionicLoading.hide();
          	});
    	     }
    	   });

	      }else{
	      	$state.go('app.agenda');
	      }
	    }, function(errMsg) {
	      $ionicLoading.hide();
	      var alertPopup = $ionicPopup.alert({
	        title: 'Login Failed!',
	        template: errMsg
	      });
	    });
    }
	};

	 $scope.showHelp = function() {
     $ionicPopup.alert({
       title: 'SKO18 Help',
       template: '<i class="icon ion-android-call"></i>+1-800-423-2500<br><br><i class="icon ion-email"></i> <a href="mailto:nabos.nimblestorageevents@travelctm.com?subject=Nimble%20SKO">Email</a><br/><br/><p>Your password can be found in the SKOFY18 App Email.</p>'
     });
   };

});