app.controller('MapCtrl', function ($scope, Maps, $ionicLoading, $stateParams, $ionicNavBarDelegate, GoogleMaps, $ionicHistory,$state,$cordovaAppAvailability,$ionicPlatform) {

	var mapID = $stateParams.mapID;
	var m = {};
	$scope.map = {};
	$scope.showNative = (window.cordova);

	$ionicLoading.show({
	  template: 'Loading...'
	});

	Maps.getMap(mapID)
	.then(function(ret){
		//console.log(ret);
	  $ionicLoading.hide();
	  m = ret;
	  if(m.mapImg){
	  	$ionicHistory.nextViewOptions({
	  	  disableBack: true
	  	});
	  	$state.go('app.mapImg', {mapID: mapID});
	  }
	  $scope.map = m;
	  var mapType = m.mapType || 'js';
	  var platform = ionic.Platform.platform();
	  $scope.map = m;
	  $ionicNavBarDelegate.title(m.title);
	  $ionicLoading.hide();
	  GoogleMaps.init(m);
	},function(err){
	  $ionicLoading.hide();
	});

	$scope.toggleStreetView = function(){
		GoogleMaps.toggleStreetView();
	};

	$scope.launchNative = function(){
  	var url;
  	var latLong = m.latitude + ',' + m.longitude;
		var platform = ionic.Platform.platform();
		if(platform === 'ios'){
			document.addEventListener("deviceready", function () {
				url = "maps:?q=" + latLong;
				$cordovaAppAvailability.check('comgooglemaps://')
				.then(function() {
					url = "comgooglemaps://?q=" + latLong + "(" + m.title + ")";
				});
			}, false);
		}else if(platform === 'android'){
			url = "geo:0,0?q=" + latLong + "(" + m.title + ")";
		}else{
			url = "https://maps.google.com?q=" + latLong + "(" + m.title + ")";
		}
		
		window.open(url, '_system');
	};

})

.controller('MapImgCtrl', function ($scope, Maps, $ionicLoading, $stateParams, $ionicNavBarDelegate) {

		var mapID = $stateParams.mapID;

		$ionicLoading.show({
		  template: 'Loading...'
		});

		Maps.getMap(mapID)
		.then(function(ret){
		  $scope.map = ret;
		  $ionicNavBarDelegate.title(ret.title);
		  $ionicLoading.hide();
		  
		},function(err){
		  $ionicLoading.hide();
		});

});