app.controller('MapsCtrl', function ($scope, Maps, $ionicLoading, $state) {

	$ionicLoading.show({
	  template: 'Loading...'
	});

	Maps.get()
	.then(function(ret){
	  $scope.maps = ret;
	  $ionicLoading.hide();
	},function(err){
	  $ionicLoading.hide();
	});

	$scope.loadMap = function(m){
		var mapType = m.mapType || 'js';
		var url;
		var platform = ionic.Platform.platform();

		if(mapType === 'native' && (platform === 'ios' || platform === 'android')){
			var latLong = m.latitude + ',' + m.longitude;

			if(platform === 'ios'){
	  		document.addEventListener("deviceready", function () {
  		    $cordovaAppAvailability.check('com.google.android.apps.maps')
  		      .then(function() {
	  					url = "comgooglemaps://?q=" + latLong + "(" + m.title + ")";
  		      }, function () {
	  					url = "maps:0,0?q=" + latLong + "&ll=" + m.title;
  		      });
  		  }, false);
			
			}else{
				url = "geo:0,0?q=" + latLong + "(" + m.title + ")";
			}
			window.open(url, '_system', 'location=yes');
			return;
		}

		$state.go(m.mapImg ? 'app.mapImg' : 'app.map', {
			mapID: m.id
		});
	};

});