﻿app.controller('PollsCtrl', function ($scope, ionicMaterialInk, Polls, AuthService, $ionicLoading, $firebaseArray, $firebaseObject) {

	// $ionicLoading.show({
	// 	template: 'Loading...'
	// });

    var ref = firebase.database().ref( "polls" );

    var activeRef = ref.orderByChild('status').equalTo('active');
    var completedRef = ref.orderByChild('status').equalTo('complete');
    var regID = AuthService.user().registrant.registrantid;

    // create a synchronized array
    // click on `index.html` above to see it used in the DOM!
    $scope.activePolls = $firebaseArray( activeRef );
    $scope.completedPolls = $firebaseArray( completedRef );

    //functions
    $scope.loaded = false;
    $scope.saveAnswer = saveAnswerFn;
    $scope.regVotes = $firebaseObject(firebase.database().ref( "reg-poll-answers/" + regID ));

    //check if the data is loaded...
    $scope.activePolls.$loaded()
        .then(function() {
        })
        .finally(function(){
            $scope.loaded = true;
        })
        .catch(function(err) {
            console.error( err );
        });

        function saveAnswerFn( pollKey, answerKey) {
            
            var prevAnswerKey =  $scope.regVotes[ pollKey ];
            //console.log(prevAnswerKey);
            if ( prevAnswerKey !== answerKey ) {
                
                //dynamic object with regID as the value
                var answerObj = {};
                answerObj[ regID ] = true;
                
                //if they even have a previous answer saved
                if ( prevAnswerKey ) {
                    var prevPollRef = firebase.database().ref( '/polls/' + pollKey );
                    var pollResultsPrevRef = firebase.database().ref( '/poll-results/' + pollKey + '/' + prevAnswerKey );
                    prevPollRef.transaction(function( poll ){
                        //console.log( poll );
                        // we only decrement the previous answer vote count not the overall vote count for the poll because they can't "un-vote"
                        if (poll.answers[ prevAnswerKey ].votes > 0) poll.answers[ prevAnswerKey ].votes--;
                        return poll;
                    });
                    
                    //remove the regID from the previous poll / answer collection
                    pollResultsPrevRef.child(regID).remove();
                }
                
                ///keep this for now since it technically works.
                var newPollRef = firebase.database().ref( '/polls/' + pollKey );
                var pollResultsRef = firebase.database().ref('/poll-results/' + pollKey + '/' + answerKey );
                var pollRegAnswersRef = firebase.database().ref( '/reg-poll-answers/' + regID );

                newPollRef.transaction(function( poll ){
                    //console.log( poll );
                    // only increase the overall poll vote if they didn't have a previous answerKey which means that this was their first time voting
                    //and not just switching their answer. Therefore only increment this on their first vote for this poll
                    if (!prevAnswerKey) poll.votes++;
                    poll.answers[ answerKey ].votes++;

                    return poll;
                });
                
                //add the regID to the poll / answer collection
                pollResultsRef.update( answerObj );

                //dynamic object with regID as the value
                var regAnswerObj = {};
                regAnswerObj[ pollKey ] = answerKey;

                // push the current answer for this poll for this registrant - the poll is the key and the answer is the value
                pollRegAnswersRef.update( regAnswerObj );

            }


        }

    


});