﻿app.controller('PostCtrl', function ($scope, ionicMaterialInk, AuthService, $ionicModal, $timeout, $stateParams, $firebaseObject, $firebaseArray, $ionicScrollDelegate) {

    //$scope.modePrefix = 'test-';
    $scope.modePrefix = '';
    
    var reg = AuthService.user().registrant;

    var postRef = firebase.database().ref( $scope.modePrefix + "feed/" + $stateParams.id );
    var commentsRef = firebase.database().ref( $scope.modePrefix + "post-comments/" + $stateParams.id  );
    var postsRegHasLikedRef = firebase.database().ref( $scope.modePrefix + "reg-liked-posts/" + reg.registrantid + '/' + $stateParams.id  );

    $scope.regLikedPostObj = $firebaseObject( postsRegHasLikedRef );

    //post object
    $scope.post = $firebaseObject( postRef );
    //comments synced array
    $scope.comments = $firebaseArray( commentsRef );

    $scope.newComment = {
      "msg" : ""
    };


    ///////////////////////////////////////
    //CTRL API methods
    $scope.saveComment = saveComment;
    $scope.doLike = doLike;

    /*
    $timeout( function() {
      $ionicScrollDelegate.$getByHandle('mainScroll').resize();
    }, 3000);
    */

    // save a comment
    function saveComment() {
      if ( $scope.newComment.msg.length ) {
        $scope.comments.$add({
            "msg": $scope.newComment.msg,
            "timestamp": firebase.database.ServerValue.TIMESTAMP,
            "like_count" : 0,
            "date_dps" : new Date(),
            "regid": reg.registrantid,
            "name": reg.registrantfirstname + ' ' + reg.registrantlastname
        }).then(function(ref){
          $scope.newComment.msg = "";
        });
        
      }
    }

    //doLike -> increment if they haven't liked it already...or decrement if they are un-liking it...
    function doLike( key ) {
      var regID = reg.registrantid;
      var hasLiked = ( $scope.regLikedPostObj.$value === null ) ? false : true;
      postRef.transaction(function(post) {
        if (hasLiked ) {
          post.like_count--;
          postsRegHasLikedRef.set(null);
        } else {
          post.like_count++;
          postsRegHasLikedRef.set(true);
        }

        
        return post;
      });
    }
});