﻿app.controller('SurveyCtrl', function ($scope, ionicMaterialInk, Survey, AuthService, $ionicLoading) {

	$ionicLoading.show({
		template: 'Loading...'
	});

	$scope.questions = [];
	$scope.results = [];

	$scope.showThankYouMsg = false;

	Survey.get()
		.then(function(ret){
			$scope.questions = ret.data;
			angular.forEach( $scope.questions, function( value, index ){
						$scope.results['q'+ value.questionID] = {
							questionID : value.questionID,
							answerText : "",
							answerTextArea : "",
							answerID : 0,
							comments : "",
							checked: false
						};
				});

			$scope.showThankYouMsg = true;
			$ionicLoading.hide();

		},function(err){
			$ionicLoading.hide();
		});

		$scope.$on("$ionicSlides.slideChangeStart", function(event, data){
			// note: the indexes are 0-based
			$scope.activeIndex = data.slider.activeIndex;
			$scope.previousIndex = data.slider.previousIndex;

			//if  we swiped forward in the wizard then lets save that data
			if ( $scope.previousIndex < $scope.activeIndex ) {
				var questionResults = $scope.results[ 'q' + $scope.questions[data.slider.previousIndex].questionID ];
				Survey.save( AuthService.user().registrant.registrantid, questionResults )
					.then(function( res ){
						// console.log( 'res' );
						// console.log( res );
					});

			}

		});


});