angular.module('service.agenda', [])

.service('Agenda', function ($http, $q, API, AuthService, CacheFactory){
  CacheFactory.createCache('EIIDscache', {
    maxAge: 15 * 60 * 1000, // Items added to this cache expire after 15 minutes
    cacheFlushInterval: 60 * 60 * 1000, // This cache will clear itself every hour
    deleteOnExpire: 'aggressive', // Items will be deleted from this cache when they expire,
    storageMode: 'localStorage'
  });

  this.get = function() {
    var dfd = $q.defer();

    this.getELI(AuthService.user().registrant.registrantid)
    .then(function(eiids){
      $http.get('agenda.json')
      .success(function(data) {
        var day1 = _.filter(data, function(event){ return event.date =="day1"; }),
            day2 = _.filter(data, function(event){ 
              // var ret = (event.date =="day2" && event.type !== 'activity') || eiids.indexOf(event.id) != -1;
              // return ret; 
              return event.date =="day2"; 
            });
            day3 = _.filter(data, function(event){ return event.date =="day3"; });
            day4 = _.filter(data, function(event){ return event.date =="day4"; });

        dfd.resolve({
          "day1": day1,
          "day2": day2,
          "day3": day3,
          "day4": day4
        });
      })
      .error(function(data) {
        dfd.reject(data);
      });
    },function(err){

    });

    

    return dfd.promise;
  };

  this.getEvent = function(eventId){
    var dfd = $q.defer();

    $http.get('agenda.json')
    .success(function(data) {
      var event = _.find(data, {id: eventId});
      dfd.resolve(event);
    })
    .error(function(data) {
      dfd.reject(data);
    });

    return dfd.promise;
  };

  this.getELI = function(registrantID) {
    var dfd = $q.defer();
    var start = new Date().getTime();

    $http.get(API.url + '/registrants/' + registrantID + '/eventItems?colList=eventitemid', {
      cache: CacheFactory.get('EIIDscache')
    })
    .success(function(ret) {
      var eids = [];
      for(var i = 0; i < ret.data.length; i++){
        eids.push(ret.data[i].eventitemid);
      }
      dfd.resolve(eids);
    })
    .error(function(data) {
      dfd.reject(data);
    });

    return dfd.promise;
  };

  this.setELI = function(elis) {
    regELIs = elis;
  };

  this.getEvent = function(eventId){
    var dfd = $q.defer();

    $http.get('agenda.json')
    .success(function(data) {
      var event = _.find(data, {id: eventId});
      dfd.resolve(event);
    })
    .error(function(data) {
      dfd.reject(data);
    });

    return dfd.promise;
  };

});