angular.module('service.maps', [])

.service('Maps', function ($http, $q){

  this.get = function() {
    var dfd = $q.defer();

    $http.get('maps.json')
    .success(function(data) {

      var floor2 = _.filter(data, function(event){ return event.type === "2nd Floor"; })
          ,floor3 = _.filter(data, function(event){ return event.type === "3rd Floor"; })
          ,floor4 = _.filter(data, function(event){ return event.type === "4th Floor"; })
          ,floor5 = _.filter(data, function(event){ return event.type === "5th Floor"; })
          ,floor41 = _.filter(data, function(event){ return event.type === "41st Floor"; })
      ;

      dfd.resolve({
        "floor2": floor2
        ,"floor3": floor3
        ,"floor5": floor5
        ,"floor4": floor4
        ,"floor41": floor41
        ,"event": event
      });
    })
    .error(function(data) {
      dfd.reject(data);
    });

    return dfd.promise;
  };

  this.getMap = function(mapID){
    var dfd = $q.defer();

    $http.get('maps.json')
    .success(function(data) {
      var map = _.find(data, {id: mapID});
      dfd.resolve(map);
    })
    .error(function(data) {
      dfd.reject(data);
    });

    return dfd.promise;
  };
})

;